# See the loader file for license and author info

require 'sketchup.rb'
module CLF_Extensions_NS

  module CLF_Label_Open_Faces
  
    def self.main
      model = Sketchup.active_model
      entities = model.entities
      selection = model.selection
      text_num = 0
      if selection.length == 0
        sel = entities
      else
        sel = selection
      end
      md = model.bounds.diagonal
      #attempts to create a leader line of a length proportional to the size of the model.  The iade is that a little mnodel should get small leaders and big models could want larger leaders.
      va = md * 0.005
      vb = md * 0.005
      vc = md * 0.02
      vec = [va,vb,vc]
      model.start_operation "Label Open Edges" # Start the Undo command
      sel.each do |e|
        if e.typename == "Edge"
          if e.faces.length == 1
            sp = e.start.position
            ep = e.end.position
            add_point = Geom::Point3d.linear_combination 0.5, sp, 0.5, ep
            entities.add_text "Open Edge #{text_num}", add_point, vec
            text_num +=1
          end
        end
      end
    model.commit_operation # End the Undo command
    UI.messagebox "#{text_num} open edges found." # Labels how many open edges were found
    end
  end
end